即日起在codingBlog上分享您的技术经验即可获得积分,积分可兑换现金哦。

C++异常处理

编程语言 xuptacm 77℃ 0评论
本文目录
[隐藏]

1.异常处理的基本概念

1. 为什么要异常处理


►在设计各种软件系统中,处理程序中的错误和其它反常行为是非常


困难的,比如服务器上长期运行的网络服务程序将80%的代码用于


实现错误检测和错误处理。

►异常是指程序运行时出现的不正常。程序运行过程中可能会出现下列异常:


►(1)CPU异常。在计算过程中,出现除数为0的情况。


►(2)内存异常:


► 使用new或malloc申请动态内存但存储空间不够;


► 数组下标越界;


► 使用野指针、迷途指针读取内存。


►(3)设备异常。


► 无法打开文件,或能够打开文件但文件有损坏,从而无法读取数据;


► 正在读取磁盘文件时挪动了文件或磁盘;


► 正在使用打印机但设备被断开;


► 正在使用的网络断线或阻塞。


►(4)用户数据异常。


► scanf输入时数据格式或类型有错误;


► 正在处理的数据库有错误;


► 程序假定的数据环境发生变化。

2. 程序的健壮性


►健壮性又称为鲁棒性,是指程序对于规范要求以外的特殊情况的处


理能力。


►健壮的程序对于规范操作以外的特殊情况能够有合理的处理方式。


►健壮性有时也和容错性、可移植性或正确性有交叉的地方。


►一个程序可以从错误的环境中推断出正确合理的内容,这是容错性


度量的标准,但也可以认为这个程序是健壮的。


►一个程序可以正确的运行在不同环境下,则认为程序的可移植性高,


也可以称该程序在不同平台下是健壮的。


►一个程序能够检测自己内部的设计或者编码错误,并得到正确的执


行结果,这是程序的正确性标准,但也可以说程序有内部的保护机


制,是健壮的。


►程序的健壮性是在异常情况下系统生存的关键所在,计算机程序在


输入错误、 磁盘故障、 网络过载或恶意攻击的情况下能否不死机


不崩溃,就是程序的健壮性。

3. 异常处理的方法


►(1)终止模型。在终止模型中,将假设错误非常关键,以至于程


序无法返回异常发生的地方继续执行。一旦异常被抛出,就表明错


误已经无法挽回,程序不能继续执行了。


►(2)恢复模型。恢复模型是指异常处理程序的工作是修正错误,


然后重新尝试调动出问题的过程。

4. 异常处理的机制


►抛出异常(throw)、检查异常(try块)、捕获异常(catch块)


►基本原理:把需要检测的程序放到try块中,把异常处理的程序放到


catch中。如果执行一个函数时出现异常,可以不在该函数中立即


处理,而是抛出异常信息,传递给它的上一级函数(调用函数),


它的上一级函数捕获到这个信息后再进行处理。如果上一级函数也


不处理,就逐级向上传递。如果传递到了最高一级(如main函数)


还不处理,最后只能异常终止程序的执行。

►C++异常处理的机制使异常与处理可以不由同一个函数来完成。这


样做的优点是使深层次的函数专注于问题求解,而不必承担处理异


常的任务,减轻了深层次函数的负担,而把处理异常的任务集中到


某一层级的函数中专门来解决。

2.异常处理的实现

1. 抛出异常


►可以使用throw表达式抛出异常,将异常抛掷给主调函数去处理。


►throw表达式的一般形式为:


►异常通常以类似于实参传递给函数的方式(由throw)抛出和(被


catch)捕获,throw表达式的类型决定了所抛出的异常类型。

throw 表达式;

►由于C++是根据类型来区分不同的异常的,因此在抛出异常时,


throw表达式的值没有实际意义,而表达式的类型则非常重要。如


果程序中有多处要抛出异常,应该用不同的表达式类型来相互区别。

if(test==0) throw test; //抛出int型异常
if(test==1) throw 'a'; //抛出char型异常
if(test==2) throw 333.23; //抛出double型异常

►关于throw的说明:


►(1)执行throw的时候,不会执行跟在throw后面的语句,而是将


程序从throw转移到匹配的catch,该catch可以是同一函数中的


catch,也可以在直接或间接调用发生异常函数的上一级函数中。


►(2)被抛出的对象是一个用throw表达式初始化的“异常对象”


。异


常对象由throw创建,并初始化为被抛出的表达式副本。异常对象


将传递给对应的catch,并在异常处理完成后撤销。因此异常对象


必须是可以复制的类型(具有复制构造函数)。


►(3)如果抛出的是数组,被抛出的对象自动该转换为指向该数组


首元素的指针,如果抛出的是一个函数,函数被转换为指向该函数


的指针。


►(4)如果抛出一个指针,该指针是一个指向派生类对象的基类指


针,则那个对象将被分割,只抛出基类的部分。


►(5)抛出指向局部对象的指针总是错误的,因为抛出指针的时候,


必须确保进入异常处理程序时指针所指向的对象仍然存在。


7


►2. 检测捕获异常


►检测捕获异常的一般形式为:

try{
…… //检测程序块(可能抛出异常的代码)
}
catch(异常说明符1) {
…… //处理程序(当异常说明符1被抛出时执行的程序)
}
catch(异常说明符1) {
…… //处理程序(当异常说明符2被抛出时执行的程序)
}
…… //更多的catch

►一个try块可以紧跟一个或多个catch块。在try中执行程序块所抛出


的异常,通常会被其中的一个catch子句处理,一旦catch子句执行


结束,程序流程继续执行紧随最后一个catch子句后面的语句。


►catch子句中的异常说明符是有一个形参的形参列表,有三种形式:

►① catch(类型名) //catch只需要了解异常的类型
►② catch(类型名 形参名) //catch需要了解异常的类型之外的信息
►③ catch(…) //捕获所有异常

9


►因为不可能知道可能被抛出的所有异常,这时使用catch(…)是非常


有效的。如果catch(…)与其他catch子句结合使用,那么它必须是最


后一个,否则任何跟在它后面的catch子句都得不到匹配检测。

try{
…… //欲检测可能发生异常的程序块
}
catch(int) { //匹配int型的异常
…… //对应int型的异常处理程序
}
catch(Point) { //匹配Point型的异常
…… //对应Point型的异常处理程序
}
catch(…) { //匹配其他类型的异常
…… //对应其他类型的异常处理程序
}

►3. 异常处理的执行过程


►(1)程序流程到达try块,然后执行try块内的程序块。如果没有引


起异常,那么跟在try块后的catch子句都不执行,程序从最后一个


catch子句后面的语句继续执行下去。


►(2)抛出异常的时候,将暂停当前函数的执行,开始查找匹配的


catch子句。


►(3)首先检查throw是否在try内部,如果是,检查catch子句,看


是否其中之一与抛出对象相匹配。如果找到匹配的catch,就处理


异常;如果找不到,就退出当前函数并释放局部对象,然后继续在


调用函数中查找。

►(4)如果找到匹配的catch,就处理异常;如果找不到,则退出调


用函数,然后继续在调用这个函数的函数中查找。


►(5)沿着嵌套函数调用链继续向上,直到为异常找到一个catch子


句。只要找到能够处理异常的catch子句,就进入该catch子句,并


在它的处理程序中继续执行。当catch结束时,跳转到该try块的最


后一个catch子句之后的语句继续执行。

//【例47.1】异常处理举例。
 #include 
 using namespace std;
 void fun(int test)
 {
 if(test==0) throw test; //抛出int型异常
if(test==1) throw 1.5; //抛出double型异常
if(test==2) throw "abc"; //抛出char *型异常
cout<<"fun调用正常结束"<void caller1(int test)
 {
 try{ //检测异常发生
 fun(test);
 }catch(int){

 cout<<"caller1捕获int->"; //捕获异常
 }
 cout<<"caller1调用正常结束"<//caller1正常结束时输出
 }
 void caller2(int test) {
 try{ //检测异常发生
 caller1(test);
 }catch(double){
 cout<<"caller2捕获double->"; //捕获异常
 }catch(...){
cout<<"caller2捕获所有未知异常->"; //捕获异常
 }
 cout<<"caller2调用正常结束"<//caller2正常结束时

 }
 int main()  { 
 for(int i=3;i>=0;i--) 
 caller2(i);  return 0; 
 }

4. 重抛异常


►在catch子句中,可以再次抛出异常。例如:


►其中throw不加表达式,表示再次抛出try块中检测到的异常表达式

throw “hello”)。

►重抛异常不能被try-catch捕获,只能传到上一级函数。

try{
throw "hello"; //抛出char *异常
}catch(const char *) { //捕获char *异常
throw; //重新抛出char *异常至上一级函数
}

其中throw不加表达式,表示再次抛出try块中检测到的异常表达式


(throw “hello”)。


►重抛异常不能被try-catch捕获,只能传到上一级函数。

转载请注明:CodingBlog » C++异常处理

喜欢 (0)or分享 (0)
发表我的评论
取消评论

*

表情